public abstract class Daten{
  public abstract void einfuegenFeldfrucht(int g);
  public abstract void ausgebenBehaelter();
  public abstract int maxGewicht();
  public abstract int getGesGewicht();
  public abstract Feldfrucht getBestFrucht(int g); // Gewicht kleiner gleich g
  public abstract void entferneLeereBehaelter();
  public void ausgebenSack(int g){ // Aufg 8
    int toleranz = gibToleranz(g);
    System.out.printf("\nSack mit %3dg ausgeben, Toleranz: +- %2dg\n",g,toleranz);
    String s="";
    if(g>getGesGewicht()) System.out.println("Nicht genug Ware vorhanden");
    else{
      int ausgeben = g;
      while(ausgeben>toleranz){
        Feldfrucht b=getBestFrucht(ausgeben); // grösste Dinger
        if(b!=null){
          s+=b.getGewicht()+" ";
          ausgeben-=b.getGewicht();
          b.setAnzahl(b.getAnzahl()-1);
        }
        else{
            System.out.println("Nicht lösbar");
            return;
        }
      }
      System.out.println(s);
      System.out.printf("Soll: %3d Ist: %3d Abweichung: %2d\n",g,g-ausgeben,-ausgeben);
    }
    entferneLeereBehaelter();
  }
  public int gibToleranz(int g){ // Aufg 7
    if(g<50) return (int) (g*0.09);
    if(g<100) return 4;
    if(g<200) return (int) (g*0.045);
    if(g<300) return 9;
    if(g<500) return (int) (g*0.03);
    if(g<1000) return 15;
    return (int) (g*0.015);
  }
}