public class DatenListe extends Daten{
  private ListKnoten kopf;
  public Feldfrucht sucheFeldfrucht(int g){
    if(kopf == null) return null;
    ListKnoten k = kopf;
    while(k!=null){
      if(k.getInhalt().getGewicht()==g) return k.getInhalt();
      k=k.getNext();
    }
    return null;
  }
  
  public void einfuegenFeldfrucht(int g){ // Aufg 2.1.4 hinten einfuegen
    if(kopf == null){
      kopf=new ListKnoten(new Feldfrucht(g));
      return;
    }
    ListKnoten k = kopf;
    while(true){
      if(k.getInhalt().getGewicht()==g){ // ist schon Lager mit h da?
        k.getInhalt().setAnzahl(k.getInhalt().getAnzahl()+1);
        return;
      }
      if(k.getNext()==null){ // kommt nix mehr?
        k.setNext(new ListKnoten(new Feldfrucht(g))); // einfuegen
        return;
      }
      k=k.getNext(); // naechtes anschauen
    }
  }
  public void einfuegenSortiertFeldfrucht(int g){
    ListKnoten nk= new ListKnoten(new Feldfrucht(g));
    if(kopf==null){
      kopf = nk;
      return;
    }
    if(kopf.getInhalt().getGewicht()==g){
      kopf.getInhalt().setAnzahl(kopf.getInhalt().getAnzahl()+1);
      return;
    }
    if(kopf.getInhalt().getGewicht()>g){ // davor einfuegen
      nk.setNext(kopf);
      kopf=nk;
      return;
    }
    ListKnoten k = kopf;
    while(k.getNext()!=null){
      if(k.getNext().getInhalt().getGewicht()==g){
        k.getNext().getInhalt().setAnzahl(k.getNext().getInhalt().getAnzahl()+1);
        return;
      }
      if(k.getNext().getInhalt().getGewicht()>g){ // davor einfuegen
        nk.setNext(k.getNext());
        k.setNext(nk);
        return;
      }
      k=k.getNext();
    }
    k.setNext(nk); // dahinter einfuegen
  }

  public void ausgebenBehaelter(){
    if(kopf==null) return;
    ListKnoten k = kopf;
    while(k!=null){
      System.out.println(k.getInhalt().getInfo());
      k=k.getNext();
    }
  }

  public int maxGewicht(){ // Aufg 3.1
    if(kopf==null) return 0;
    ListKnoten k = kopf;
    int max=k.getInhalt().getGewicht();
    k = k.getNext();
    while(k!=null){
      if(max<k.getInhalt().getGewicht())max=k.getInhalt().getGewicht();
      k=k.getNext();
    }
    return max;
  }
  public int getGesGewicht(){ // Aufg 4.1
    if(kopf == null)return 0;
    ListKnoten k = kopf;
    int sum=0;
    while(k!=null){
      sum+=k.getInhalt().getGewicht()*k.getInhalt().getAnzahl();
      k=k.getNext();
    }
    return sum;
  }
  public Feldfrucht getBestFrucht(int g){ // Aufg 5.1
    if(kopf == null) return null;
    ListKnoten k = kopf;
    Feldfrucht fruchtMaxKG= null; // größte Frucht mit gewicht<=g
    int maxKG=0;
    Feldfrucht fruchtMinG= null; // kleinste Frucht mit gewicht>g
    int minG=Integer.MAX_VALUE;
    while(k!=null){
      if(g==k.getInhalt().getGewicht() && k.getInhalt().getAnzahl()>0) return k.getInhalt();
      if(k.getInhalt().getGewicht()<=g && k.getInhalt().getAnzahl()>0 && k.getInhalt().getGewicht()>maxKG){
        fruchtMaxKG=k.getInhalt();
        maxKG=fruchtMaxKG.getGewicht();
      }
      if(k.getInhalt().getGewicht()>g && k.getInhalt().getAnzahl()>0 && k.getInhalt().getGewicht()<minG){
        fruchtMinG=k.getInhalt();
        minG=fruchtMinG.getGewicht();
      }
      k=k.getNext();
    }
    if(fruchtMaxKG!=null) return fruchtMaxKG;
    return fruchtMinG;
  }
  public void entferneLeereBehaelter(){
    if(kopf == null)return;
    if(kopf.getInhalt().getAnzahl()==0){ // ersten Knoten löschen
      kopf = kopf.getNext();
    }
    ListKnoten k = kopf;
    while(k!=null){
      if(k.getNext()==null) return; // Ende der Liste
      if(k.getNext().getInhalt().getAnzahl()==0){
        k.setNext(k.getNext().getNext());
      }
      k=k.getNext();
    }
  }
}