public class BaumKnoten{
  private Feldfrucht inhalt;
  private BaumKnoten  linkerTeilbaum;
  private BaumKnoten rechterTeilbaum;
  public BaumKnoten(Feldfrucht f){
    inhalt = f;    
  }
  public Feldfrucht getInhalt(){
    return inhalt;
  }
  public BaumKnoten gibLinkenTeilbaum(){
    return linkerTeilbaum;
  }
  public BaumKnoten gibRechtenTeilbaum(){
    return rechterTeilbaum;
  }
  public void setLinkenTeilbaum(BaumKnoten k){
    linkerTeilbaum = k;
  }
  public void setRechtenTeilbaum(BaumKnoten k){
    rechterTeilbaum = k;
  } 
  public void ausgebenDatenInorder(){
    if(linkerTeilbaum != null){
      linkerTeilbaum.ausgebenDatenInorder();
    }
    System.out.println(inhalt.getInfo()); // inhalt.ausgebenDaten()
    if(rechterTeilbaum != null){
      rechterTeilbaum.ausgebenDatenInorder();
    }
  }
  public void einfuegenFeldfrucht(int g){ // Aufg 2.2.4
    if(inhalt.getGewicht()==g){
      inhalt.setAnzahl(inhalt.getAnzahl()+1);
    }
    else{
      if(g < inhalt.getGewicht()){
        if(linkerTeilbaum==null){
          linkerTeilbaum= new BaumKnoten(new Feldfrucht(g));
        }
        else linkerTeilbaum.einfuegenFeldfrucht(g);
      }
      else{
        if(rechterTeilbaum==null){
          rechterTeilbaum= new BaumKnoten(new Feldfrucht(g));
        }
        else rechterTeilbaum.einfuegenFeldfrucht(g);
      }
    }
  }
  public int maxGewicht(){ // Aufg 3.2
    if(rechterTeilbaum==null) return inhalt.getGewicht();
    return rechterTeilbaum.maxGewicht();
  }
  public void ausgebenBaum2D(String praefix, boolean istLinks, boolean istOberster) { // Danke Sabine
    if (rechterTeilbaum != null) {  // Rechten Teilbaum ausgeben
      if (istLinks && !istOberster)
        rechterTeilbaum.ausgebenBaum2D(praefix + "|   ", false, false); // Richtungsumkehr --> Strich zeichnen
      else 
        rechterTeilbaum.ausgebenBaum2D(praefix + "    ", false, false);
    }
    if (istLinks) // Knoten selbst ausgeben
      System.out.println(praefix + "└── " + inhalt.getInfoKurz());
    else if (istOberster)
      System.out.println(praefix + "─── " + inhalt.getInfoKurz());
    else 
      System.out.println(praefix + "┌── " + inhalt.getInfoKurz());
    if (linkerTeilbaum != null) { // Linken Teilbaum ausgeben
      if (istLinks || istOberster)
        linkerTeilbaum.ausgebenBaum2D(praefix + "    ", true, false);
      else 
        linkerTeilbaum.ausgebenBaum2D(praefix + "|   ", true, false); // Richtungsumkehr --> Strich zeichnen
    }
  }
  public int getGesGewicht(){ // Aufg 4.2
    int sum=inhalt.getGewicht()*inhalt.getAnzahl();
    if(rechterTeilbaum!=null) sum+= rechterTeilbaum.getGesGewicht();
    if(linkerTeilbaum!=null) sum+= linkerTeilbaum.getGesGewicht();
    return sum;
  }
}