import java.util.*;
public class DatenBaum extends Daten{
  private BaumKnoten wurzel;
  public void einfuegenFeldfrucht(int g){ // Aufg 2.2.4
    if (wurzel==null){
      wurzel = new BaumKnoten (new Feldfrucht(g));
    }
    else wurzel.einfuegenFeldfrucht(g);
  }
  public void ausgebenBehaelter(){ // Danke Sabine
    wurzel.ausgebenBaum2D("", false, true);
  }
  public int maxGewicht(){ // Aufg 3.2
    if(wurzel==null) return 0;
    return wurzel.maxGewicht();
  }
  /*public int getGesGewicht(){ // Aufg 4.2
    if(wurzel==null) return 0;
    return wurzel.getGesGewicht();
  }*/
  public int getGesGewicht(){ // Aufg 4.3
    if(wurzel==null) return 0;
    Deque<BaumKnoten> stack = new ArrayDeque<BaumKnoten>();
    int sum=0;
    BaumKnoten k;
    stack.push(wurzel);
    while(!stack.isEmpty()){
      k=stack.pop();
      if(k.gibRechtenTeilbaum()!=null) stack.push(k.gibRechtenTeilbaum());
      if(k.gibLinkenTeilbaum()!=null) stack.push(k.gibLinkenTeilbaum());
      sum += k.getInhalt().getGewicht()*k.getInhalt().getAnzahl();
    }
    return sum;
  }
  public Feldfrucht getBestFrucht(int g){ // Aufg 5.2 Baum in Preoder durchsuchen
    if(wurzel==null) return null;
    Deque<BaumKnoten> stack = new ArrayDeque<BaumKnoten>();
    BaumKnoten k;
    Feldfrucht fruchtMaxKG= null; // größte Frucht mit gewicht<=g
    int maxKG=0;
    Feldfrucht fruchtMinG= null; // kleinste Frucht mit gewicht>g
    int minG=Integer.MAX_VALUE;
    stack.push(wurzel);
    while(!stack.isEmpty()){
      k=stack.pop();
      if(k.gibRechtenTeilbaum()!=null) stack.push(k.gibRechtenTeilbaum());
      if(k.gibLinkenTeilbaum()!=null) stack.push(k.gibLinkenTeilbaum());
      if(g==k.getInhalt().getGewicht() && k.getInhalt().getAnzahl()>0) return k.getInhalt();
      if(k.getInhalt().getGewicht()<=g && k.getInhalt().getAnzahl()>0 && k.getInhalt().getGewicht()>maxKG){
        fruchtMaxKG=k.getInhalt();
        maxKG=fruchtMaxKG.getGewicht();
      }
      if(k.getInhalt().getGewicht()>g && k.getInhalt().getAnzahl()>0 && k.getInhalt().getGewicht()<minG){
        fruchtMinG=k.getInhalt();
        minG=fruchtMinG.getGewicht();
      }
    }
    if(fruchtMaxKG!=null) return fruchtMaxKG;
    return fruchtMinG;
  }
  public void entferneLeereBehaelter(){} // Dummy
}